How do you return to a sourced bash script?

2019-01-09 02:12发布

问题:

I use a script that extends using the bash source feature;

#!/bin/bash

source someneatscriptthatendsprematurely.sh

I would like to be able to return from that script, without breaking the main script.

Using exit breaks the main script, return is only valid in functions and experimenting with $(exit 1) does not seem to work either.

So, is it possible to return in a sub-bash script without breaking the main bash?

Any help appreciated!

回答1:

You need the return statement:

return [n]

Causes a function to exit with the return value specified by n. If n is omitted, the return status is that of the last command executed in the function body. If used outside a function, but during execution of a script by the . (source) command, it causes the shell to stop executing that script and return either n or the exit status of the last command executed within the script as the exit status of the script. If used outside a function and not during execution of a script by ., the return status is false. Any command associated with the RETURN trap is executed before execution resumes after the function or script.

You can see this in action with the following two scripts:

script1.sh:
    . script2.sh
    echo hello again
script2.sh:
    echo hello
    return
    echo goodbye

When you run script1.sh, you see:

hello
hello again


回答2:

Is it important that you can change environment variables? Since otherwise you can just execute the script by executing it without source:

someneatscriptthatendsprematurely.sh


回答3:

I had the same problem just now

I realized that adding a checker function and returning that will not also return the function on its caller for example.

On bash_functions

function install_packer_linux() {
  check_wget && check_unzip
  wget https://releases.hashicorp.com/packer/1.1.2/packer_1.1.2_linux_amd64.zip
  unzip packer_1.1.2_linux_amd64.zip
  mv packer ~/.local/bin
  rm -f packer_1.1.2_linux_amd64.zip
}


function check_unzip() {
  if ! [ -x "$(command -v unzip)" ]; then
    echo "Error: unzip is not installed"
    return 1
  else
    return 0
  fi
}

function check_wget() {
  if ! [ -x "$(command -v wget)" ]; then
    echo "Error!: wget is not installed"
    return 1
  else
    return 0
  fi
}


$ source ~/.bash_functions

What happens here is since the checkers is the only place its returned so install_packer_linux will still continue

So you can do two things here. Either keep the current format (function calling another function) as is and evaluate using truthy value then return if the values are not truthy or rewrite the checker on the main installer_packer_linux function

Truthy:

function install_packer_linux() {
  check_wget && check_unzip || return
  wget https://releases.hashicorp.com/packer/1.1.2/packer_1.1.2_linux_amd64.zip
  unzip packer_1.1.2_linux_amd64.zip
  mv packer ~/.local/bin
  rm -f packer_1.1.2_linux_amd64.zip
}

Notice we added || return after the checks and concatenated the checks using && so if not both checks are truthy we return the function